// Repeat - run a program repeatedly
// Copyright  2010 Richard Kettlewell
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

#include "stdafx.h"

using namespace std;

int main(void)
{
    // Get the full, unparsed command line
    string cmd = GetCommandLineA();

    // Find the end of the first 'word'
    // Reference: http://msdn.microsoft.com/en-us/library/17w5ykft.aspx
    string::size_type pos = 0;
    while(pos < cmd.size() && cmd[pos] != ' ' && cmd[pos] != '\t') {
        if(cmd[pos] == '"') {
            // Quotes protect whitespace
            ++pos;
            while(pos < cmd.size() && cmd[pos] != '"') {
                if(cmd[pos] == '\\') {
                    ++pos;
                    if(pos < cmd.size() && (cmd[pos] == '\\' || cmd[pos] == '"'))
                        ++pos;
                } else
                    ++pos;
            }
            // Step over close quote
            if(pos < cmd.size())
                ++pos;
        } else if(cmd[pos] == '\\') {
            // Backslashes escape themselves and quotes if they separated
            // from a quote only by other backslashes, but otherwise
            // act like any other character.  (This should make your head
            // spin.)  We don't actually care whether they represent
            // one backslash or two, just about their effect on any
            // subsequent quote character.
            //
            // For example:
            //      .\"Repeat.exe"  -> escapes the "
            //      .\\"Repeat.exe" -> does not escape the "
            ++pos;
            if(pos < cmd.size() && (cmd[pos] == '\\' || cmd[pos] == '"'))
                ++pos;
        } else
            ++pos;
    }
    //cerr << "Command name: " << cmd.substr(0, pos) << endl;
    while(pos < cmd.size() && (cmd[pos] == ' ' || cmd[pos] == '\t'))
        ++pos;
    //cerr << "Arguments: " << cmd.substr(pos) << endl;
    string arg = cmd.substr(pos);
    for(;;) {
        system(arg.c_str());
        Sleep(1000/*ms*/);
    }
    return 0;
}
